//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Form.h"
#include "MQBasePlugin.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TForm1 *Form1;

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule,
					   DWORD  ul_reason_for_call,
					   LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
class MQVertexListPlugin : public MQStationPlugin
{
	friend class TForm1;

protected:
	TForm1 *m_pForm;
	bool m_bActivate;

public:
	MQVertexListPlugin();
	virtual ~MQVertexListPlugin();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);

	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);

	// IuWFNg̕ҏW
	virtual void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// AhDs
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	// hDs
	virtual BOOL OnRedo(MQDocument doc, int redo_state);
	// IuWFNg̕ҏW
	virtual void OnObjectModified(MQDocument doc);
	// JgIuWFNg̕ύX
	virtual void OnUpdateObjectList(MQDocument doc);
	// }eA̕ҏW
	virtual void OnMaterialModified(MQDocument doc);
	// Jg}eA̕ύX
	virtual void OnUpdateMaterialList(MQDocument doc);


	typedef bool (MQVertexListPlugin::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	// ʂ̍폜
	bool DeleteFace(MQDocument doc);
	// XgXV
	bool UpdateList(MQDocument doc);
	// JgIuWFNgύX
	bool ChangeCurrentObject(MQDocument doc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	virtual bool ExecuteCallback(MQDocument doc, void *option);
};


static MQVertexListPlugin plugin;


// RXgN^
MQVertexListPlugin::MQVertexListPlugin()
{
	m_pForm = NULL;
	m_bActivate = false;
}

// RXgN^
MQVertexListPlugin::~MQVertexListPlugin()
{
	if (m_pForm != NULL){
		// Exit()Ŕj͂ꉞÔ߂ł
		delete m_pForm;
		m_pForm = NULL;
	}
}

//---------------------------------------------------------------------------
//  GetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
void MQVertexListPlugin::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x4BC91023;
}

//---------------------------------------------------------------------------
//  GetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
const char *MQVertexListPlugin::GetPlugInName(void)
{
	return "Object information with VCL       Copyright(C) 2006, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
const char *MQVertexListPlugin::EnumString(void)
{
	return "Object information";
}


// AvP[V̏
BOOL MQVertexListPlugin::Initialize()
{
	if (m_pForm == NULL){
		// AvP[VɃCEChẼnh蓖
		Application->Handle = MQ_GetWindowHandle();

		// tH[̍쐬
		m_pForm = new TForm1(Application, this);
		m_pForm->Visible = m_bActivate;
	}
	return TRUE;
}

// AvP[V̏I
void MQVertexListPlugin::Exit()
{
	if (m_pForm != NULL){
		delete m_pForm;
		m_pForm = NULL;
	}
}

// \E\؂ւv
BOOL MQVertexListPlugin::Activate(MQDocument doc, BOOL flag)
{
	if (m_pForm == NULL)
		return FALSE;

	m_bActivate = flag;
	m_pForm->Visible = m_bActivate;
	if (m_pForm->Visible){
		m_pForm->UpdateList(doc, true, true);
	}
	return m_bActivate;
}

// \E\Ԃ̕ԓ
BOOL MQVertexListPlugin::IsActivated(MQDocument doc)
{
	if (m_pForm == NULL)
		return FALSE;

	return m_bActivate;
}


// IuWFNg̕ҏW
void MQVertexListPlugin::OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param)
{
	m_pForm->UpdateList(doc, true, true);
}

// AhDs
BOOL MQVertexListPlugin::OnUndo(MQDocument doc, int undo_state)
{
	m_pForm->UpdateList(doc, true, true);

	// ʂȃAhDsĂȂ̂FALSEԂ
	return FALSE;
}

// hDs
BOOL MQVertexListPlugin::OnRedo(MQDocument doc, int redo_state)
{
	m_pForm->UpdateList(doc, true, true);

	// ʂȃhDsĂȂ̂FALSEԂ
	return FALSE;
}

// IuWFNg̕ҏW
void MQVertexListPlugin::OnObjectModified(MQDocument doc)
{
	m_pForm->UpdateList(doc, true, false);
}

// JgIuWFNg̕ύX
void MQVertexListPlugin::OnUpdateObjectList(MQDocument doc)
{
	m_pForm->UpdateList(doc, true, false);
}

// }eA̕ҏW
void MQVertexListPlugin::OnMaterialModified(MQDocument doc)
{
	m_pForm->UpdateList(doc, false, true);
}

// Jg}eA̕ύX
void MQVertexListPlugin::OnUpdateMaterialList(MQDocument doc)
{
	m_pForm->UpdateList(doc, false, true);
}


// ʂ
bool MQVertexListPlugin::DeleteFace(MQDocument doc)
{
	MQObject obj = doc->GetObject(doc->GetCurrentObjectIndex());
	if (obj == NULL)
		return false;

	// XgőIĂʂ
	int count = m_pForm->ListFace->Items->Count;
	for (int i=0; i<count; i++){
		if (m_pForm->ListFace->Items->Item[i]->Selected){
			int index = m_pForm->ListFace->Items->Item[i]->SubItems->Strings[0].ToInt();
			obj->DeleteFace(index);
		}
	}

	// ύXŝtrueԂ
	return true;
}

// XgXV
bool MQVertexListPlugin::UpdateList(MQDocument doc)
{
	m_pForm->UpdateList(doc, true, true);
	return false; // ύXĂȂ̂falseԂ
}

// JgIuWFNgύX
bool MQVertexListPlugin::ChangeCurrentObject(MQDocument doc)
{
	if (m_pForm->ListObject->Selected != NULL){
		int index = (int)m_pForm->ListObject->Selected->Data;
		doc->SetCurrentObjectIndex(index);
	}
	return true;
}


bool MQVertexListPlugin::ExecuteCallback(MQDocument doc, void *option)
{
	CallbackInfo *info = (CallbackInfo*)option;
	return ((*this).*info->proc)(doc);
}

void MQVertexListPlugin::Execute(ExecuteCallbackProc proc)
{
	CallbackInfo info;
	info.proc = proc;
	BeginCallback(&info);
}

// vOC̃x[XNXԂ
MQBasePlugin *GetPluginClass()
{
	return &plugin;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner, MQVertexListPlugin *plugin)
	: TForm(Owner)
{
	m_pPlugin = plugin;
}
//---------------------------------------------------------------------------
void TForm1::UpdateList(MQDocument doc, bool object, bool material)
{
	// tH[\ȂXVȂ
	if (!Visible)
		return;

	int curobj_idx = doc->GetCurrentObjectIndex();
	MQObject obj = doc->GetObject(curobj_idx);
	if (obj == NULL && object){
		ListVertex->Items->Clear();
		ListFace->Items->Clear();
		return;
	}

	// IuWFNgXgXV
	if (PageControl1->ActivePage == TabSheetObject && object){
		ListObject->Items->BeginUpdate();
		ListObject->Items->Clear();
		int numObj = doc->GetObjectCount();
		for (int i=0; i<numObj; i++){
			MQObject obj = doc->GetObject(i);
			if (obj == NULL)
				continue;

			int numVert = obj->GetVertexCount();
			int numVertCount = 0;
			for (int i=0; i<numVert; i++){
				if (obj->GetVertexRefCount(i) != 0)
					numVertCount++;
			}

			int numFace = obj->GetFaceCount();
			int numFaceCount = 0;
			for (int i=0; i<numFace; i++){
				if (obj->GetFacePointCount(i) > 0)
					numFaceCount++;
			}

			TListItem *item = ListObject->Items->Add();
			char name[64];
			obj->GetName(name, sizeof(name));
			item->Caption = AnsiString(i);
			item->SubItems->Add(AnsiString(name));
			item->SubItems->Add(AnsiString(obj->GetUniqueID()));
			item->SubItems->Add(AnsiString(obj->GetDepth()));
			item->SubItems->Add(AnsiString(numVertCount));
			item->SubItems->Add(AnsiString(numFaceCount));
			item->Data = (void*)i;
		}
		ListObject->Items->EndUpdate();
	}

	// _XgXV
	if (PageControl1->ActivePage == TabSheetVertex && object){
		int numVert = obj->GetVertexCount();
		int numVertCount = 0;
		for (int i=0; i<numVert; i++){
			if (obj->GetVertexRefCount(i) != 0)
				numVertCount++;
		}
		ListVertex->Items->BeginUpdate();
		ListVertex->Items->Clear();
		for (int i=0; i<numVert; i++){
			if (obj->GetVertexRefCount(i) != 0){
				MQPoint p = obj->GetVertex(i);
				TListItem *item = ListVertex->Items->Add();
				item->Caption = AnsiString(i);
				item->SubItems->Add(obj->GetVertexUniqueID(i));
				item->SubItems->Add(FloatToStrF(p.x, ffFixed, 6, 3));
				item->SubItems->Add(FloatToStrF(p.y, ffFixed, 6, 3));
				item->SubItems->Add(FloatToStrF(p.z, ffFixed, 6, 3));
			}
		}
		ListVertex->Items->EndUpdate();
	}

	// ʃXgXV
	if (PageControl1->ActivePage == TabSheetFace && object){
		int numFace = obj->GetFaceCount();
		int numFaceCount = 0;
		for (int i=0; i<numFace; i++){
			if (obj->GetFacePointCount(i) > 0)
				numFaceCount++;
		}
		ListFace->Items->BeginUpdate();
		ListFace->Items->Clear();
		for (int i=0; i<numFace; i++){
			int count = obj->GetFacePointCount(i);
			if (count > 0){
				TListItem *item = ListFace->Items->Add();
				item->Caption = AnsiString(i);
				item->SubItems->Add(AnsiString(obj->GetFaceUniqueID(i)));
				item->SubItems->Add(AnsiString(count));
				AnsiString vi = "[";
				int array[4];
				obj->GetFacePointArray(i, array);
				for (int j=0; j<count; j++){
					if (j > 0) vi += ",";
					vi += AnsiString(array[j]);
				}
				vi += "]";
				item->SubItems->Add(vi);
				item->SubItems->Add(AnsiString(obj->GetFaceMaterial(i)));
			}
		}
		ListFace->Items->EndUpdate();
	}

	// }eAXgXV
	if (PageControl1->ActivePage == TabSheetMaterial && material){
		ListMaterial->Items->BeginUpdate();
		ListMaterial->Items->Clear();
		int numMat = doc->GetMaterialCount();
		for (int i=0; i<numMat; i++){
			MQMaterial mat = doc->GetMaterial(i);
			if (mat == NULL)
				continue;

			TListItem *item = ListMaterial->Items->Add();
			char name[64];
			mat->GetName(name, sizeof(name));
			item->Caption = AnsiString(i);
			item->SubItems->Add(AnsiString(name));
			item->SubItems->Add(AnsiString(mat->GetUniqueID()));
			item->Data = (void*)i;
		}
		ListMaterial->Items->EndUpdate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caHide;

	m_pPlugin->m_bActivate = false;
	m_pPlugin->WindowClose();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonFaceDeleteClick(TObject *Sender)
{
	m_pPlugin->Execute(&MQVertexListPlugin::DeleteFace);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PageControl1Change(TObject *Sender)
{
	m_pPlugin->Execute(&MQVertexListPlugin::UpdateList);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListObjectClick(TObject *Sender)
{
	m_pPlugin->Execute(&MQVertexListPlugin::ChangeCurrentObject);
}
//---------------------------------------------------------------------------

